(in-package  :examples)
(use-package :oli)

;;----------------------------------------------------------------------------------------------*
;; Vorgaben setzen:                   ;; Moeglicher Vorgabewerte:
;;----------------------------------------------------------------------------------------------*
(setf mlinie_merker "Bohrung")        ;; "Bohrung" , "Mittelpunkt"
(setf ml_aendern_merker t)            ;; t , nil
(setf Geofarbe 0,1,0)                 ;; 1,1,1 ==> RGB-Wert je nach gew. Farbe
(setf Geolinientyp :DOT_CENTER)       ;; :SOLID :DOTTED :DASHED :LONG_DASHED :DOT_CENTER
                                      ;; :DASH_CENTER :CENTER_DASH_DASH :PHANTOM
(setf Mlfarbe 0,1,1)                  ;; 1,1,1 ==> RGB-Wert je nach gew. Farbe
(setf Mllinientyp :PHANTOM)           ;; :SOLID :DOTTED :DASHED :LONG_DASHED :DOT_CENTER
                                      ;; :DASH_CENTER :CENTER_DASH_DASH :PHANTOM
;;----------------------------------------------------------------------------------------------*

(sd-defdialog 'am-teilkreisgeo
  :dialog-title "Teilkreisgeo"
  :toolbox-button t
  :after-initialization
  (progn
    (setf Geofarbe_aktuell (sd-am-geo-attributes-struct-color (sd-am-inq-curr-geometry-attributes)))
    (setf Geolinientyp_aktuell (sd-am-geo-attributes-struct-linetype (sd-am-inq-curr-geometry-attributes)))
    (setf Ml_abs_offset (sd-am-center-line-settings-struct-abs-offset (sd-am-inq-curr-center-line-settings)))
    (setf Ml_rel_offset (sd-am-center-line-settings-struct-rel-offset (sd-am-inq-curr-center-line-settings)))
  )
  :variables
  '((Besitzer    ;;:value-type :docupart
                 :selection *sd-anno-view-seltype*
                 :select-attribute :docu-calc-geo-only
                 :title "Besitzer"
                 :prompt-text "Ansicht fuer Teilkreisgeo angeben."
                 :after-input
                 (progn
                   (setf Massstab_ansicht (sd-am-view-struct-scale (sd-am-inq-view Besitzer)))
                 )
    )
    ("Initialisierungspunkte")
    (Mittelpunkt :value-type :docupntcnp
                 :selection (*sd-anno-geo-seltype* *sd-anno-center-line-seltype* *sd-anno-symmetry-line-seltype*)
                 ;;:select-attribute :docu-calc-geo-only
                 :multiple-items nil
                 :title "Mittelpunkt"
                 :prompt-text "Mittelpunkt fuer Teilkreisgeo angeben."
                 :initial-value nil
                 :after-input
                 (progn
                   (setf Mittelpunkt (make-gpnt2d :x (oli::gpntdocu_x Mittelpunkt) :y (oli::gpntdocu_y Mittelpunkt)))
                   (setf Mittelpunkt (sd-vec-scale Mittelpunkt (/ 1 Massstab_ansicht)))
                 )
    )
    (Bohrungen   ;;:value-type :docupntcnp
                 :selection (*sd-anno-circle-seltype* *sd-anno-arc-seltype*)
                 :select-attribute :docu-calc-geo-only
                 :multiple-items t
                 :show-select-menu t
                 :incremental-selection t
                 :title "Bohrung(en)"
                 :prompt-text "Bohrungen fuer Teilkreisgeo angeben."
    )
    ("-")
    ("Autom. erstellte Mittellinien")
    (ml_aendern  :value-type :boolean
                 :title "In Unsichtbare ndern"
                 :toggle-type :wide-toggle
                 :initial-value (if ml_aendern_merker t nil)
                 :after-input
                 (if ml_aendern
                   (setf ml_aendern_merker t)
                   (setf ml_aendern_merker nil)
                 )
    )
    ("-")
    ("Teilkreisgeo erstellen")
    (mlinie_b    :value-type :boolean
                 :title "Nur bei Bohrung selbst"
                 :toggle-type :wide-toggle
                 :initial-value (if (equal mlinie_merker "Bohrung") t nil)
                 :after-input
                 (progn
                   (setf mlinie_merker "Bohrung")
                   (setf mlinie_b t)
                   (setf mlinie_m nil)
                 )
    )
    (mlinie_m    :value-type :boolean
                 :title "Mittelpunkt bis Bohrung"
                 :toggle-type :wide-toggle
                 :initial-value (if (equal mlinie_merker "Mittelpunkt") t nil)
                 :after-input
                 (progn
                   (setf mlinie_merker "Mittelpunkt")
                   (setf mlinie_b nil)
                   (setf mlinie_m t)
                 )
    )
   )
  :local-functions
  '((ok_ausfuehren ()
      (let (Einzelbohrung Zentrum Radius ueberstand winkel anfangspunkt endpunkt Rechteckpunkt_1 Rechteckpunkt_2)
        (progn
          ;; Geoemtrieeinstellungen setzen
          (am_geo_color :rgb Geofarbe :done)
          (am_geo_ltype Geolinientyp :done)

          ;; Alle Bohrungen in der Liste abarbeiten
          (dolist (Einzelbohrung Bohrungen)
            (progn
              ;; Werte fuer Boegen auslesen
              (when (sd-am-arc-struct-p (sd-am-inq-specific-geo-props Einzelbohrung))
                (setf Zentrum (sd-am-arc-struct-center (sd-am-inq-specific-geo-props Einzelbohrung)))
                (setf Radius (sd-am-arc-struct-radius (sd-am-inq-specific-geo-props Einzelbohrung)))
              )
              ;; Werte fuer Kreise auslesen
              (when (sd-am-circle-struct-p (sd-am-inq-specific-geo-props Einzelbohrung))
                (setf Zentrum (sd-am-circle-struct-center (sd-am-inq-specific-geo-props Einzelbohrung)))
                (setf Radius (sd-am-circle-struct-radius (sd-am-inq-specific-geo-props Einzelbohrung)))
              )

              (setf Zentrum (sd-vec-scale Zentrum (/ 1 Massstab_ansicht)))
              (setf Radius (/ Radius Massstab_ansicht))

              ;; Haelfte des Mittellinienueberstandes fuer die Bohrung berechnen
              (setf ueberstand
                (+
                  (+ Radius Ml_abs_offset)
                  (* Radius Ml_rel_offset)
                )
              )
              ;; Teilkreisgeo erstellen fuer Auswahl-Option: "Nur bei Bohrung selbst"
              (when mlinie_b
                (progn
                  ;; Halbe Linie erstellen vom Zentrum Richtung zu Mittelpunkt
                  (sd-am-create-geo-straight
                    :angle (list
                             Zentrum     ;; Startpunkt
                             Mittelpunkt ;; Richtungspunkt
                             ueberstand  ;; Laenge
                           )
                    :owner_type :2dview
                    :owner Besitzer
                  )
                  ;; Halbe Linie erstellen vom Zentrum Richtung weg vom Mittelpunkt
                  (sd-am-create-geo-straight
                    :angle (list
                             Zentrum        ;; Startpunkt
                             Mittelpunkt    ;; Richtungspunkt
                             (- ueberstand) ;; Laenge
                           )
                    :owner_type :2dview
                    :owner Besitzer
                  )
                )
              )
              ;; Teilkreisgeo erstellen fuer Auswahl-Option: "Mittelpunkt bis Bohrung"
              (when mlinie_m
                (progn
                  ;; Laenge vom Mittelpunkt zum Zentrumspunkt der Bohrung berechnen
                  (setf laenge (sd-vec-subtract Zentrum Mittelpunkt))
                  (setf laenge (sd-vec-length laenge))
                  ;; Linie erstellen
                  (sd-am-create-geo-straight
                    :angle (list
                             Mittelpunkt           ;; Startpunkt
                             Zentrum               ;; Richtungspunkt
                             (+ laenge ueberstand) ;; Laenge
                           )
                    :owner_type :2dview
                    :owner Besitzer
                  )
                )
              )
              ;; Mittellinie aendern fuer Auswahl-Option: "In Unsichtbare ndern"
              ;; Wenn diese nur geloescht wird, dann werden diese wieder neu erstellt, sobald eine
              ;; Aenderung am 3D-Modell stattfindet oder auch eine erzw. Aktualisierung durchgef. wird !
              (when ml_aendern
                (progn
                  (setf Rechteckpunkt_1 (sd-vec-subtract Zentrum (make-gpnt2d :x (* ueberstand 1.01) :y (* ueberstand 1.01))))
                  (setf Rechteckpunkt_2 (sd-vec-add Zentrum (make-gpnt2d :x (* ueberstand 1.01) :y (* ueberstand 1.01))))
                  (setf Rechteckpunkt_1 (sd-vec-scale Rechteckpunkt_1 Massstab_ansicht))
                  (setf Rechteckpunkt_2 (sd-vec-scale Rechteckpunkt_2 Massstab_ansicht))                  
                  (sd-call-cmds
                    (AM_AUX_GEO_MODIFY_SETTING
                      :AUX_SELECT
                      :docu_center_line
                      :by_box_docu_geo
                      (oli::gpntdocu (gpnt2d_x Rechteckpunkt_1) (gpnt2d_y Rechteckpunkt_1) "Annotation")
                      (oli::gpntdocu (gpnt2d_x Rechteckpunkt_2) (gpnt2d_y Rechteckpunkt_2) "Annotation")                      
                      :color :rgb Mlfarbe :done
                      :line_type Mllinientyp
                    )
                    ;;:failure (progn
                    ;;           (sd-display-error "Fehler beim ndern einer vorhandenen Mittellinie in Unsichtbare !")
                    ;;         )
                    ;;:success (display "Mittellinie wurde korrekt gelndert")
                  )
                )
              )
            )
          )
          ;; Teilkreis erstellen mittels gewaehltem Mittelpunkt und dem Zentrumspunkt der zuletzt
          ;; ermittelten Bohrung aus der Liste
          (sd-am-create-geo-circular
            :radius (list
                      Mittelpunkt
                      Zentrum
                    )
            :owner_type :2dview
            :owner Besitzer
          )
          ;; Erstellten Teilkreis sofort bemassen
          (am_create_dim_diamtr
            :pick1 (sd-vec-scale Zentrum (* 1 Massstab_ansicht))
            :prefix "Tk"
            Zentrum
          )
          ;; Bemassung zum positionieren auf den Cursor haengen
          (sd-put-buffer (format nil "am_dim_move_dim ~a" (sd-vec-scale Zentrum (* 1 Massstab_ansicht))))
          ;; Aktuelle Geoemtrieeinstellungen wieder herstellen
          (am_geo_color :rgb Geofarbe_aktuell :done)
          (am_geo_ltype Geolinientyp_aktuell :done)
        )
      )
    )
   )
  :ok-action
  '(ok_ausfuehren)
  :cancel-action
  '()
)
